import {GameMode, EquipmentSlot, system, world} from "@minecraft/server";

world.sendMessage("Loaded")

const acceptedBlocks = [
    "minecraft:tuff", 
    ///////////////////
    //    concrete   //
    ///////////////////
    "minecraft:white_concrete",
    "minecraft:light_gray_concrete",
    "minecraft:gray_concrete",
    "minecraft:black_concrete",
    "minecraft:brown_concrete",
    "minecraft:red_concrete",
    "minecraft:orange_concrete",
    "minecraft:yellow_concrete",
    "minecraft:lime_concrete",
    "minecraft:green_concrete",
    "minecraft:cyan_concrete",
    "minecraft:light_blue_concrete",
    "minecraft:blue_concrete",
    "minecraft:purple_concrete",
    "minecraft:magenta_concrete",
    "minecraft:pink_concrete",

    ///////////////////
    //// Terracotta ///
    ///////////////////
    "minecraft:white_terracotta",
    "minecraft:light_gray_terracotta",
    "minecraft:gray_terracotta",
    "minecraft:black_terracotta",
    "minecraft:brown_terracotta",
    "minecraft:red_terracotta",
    "minecraft:orange_terracotta",
    "minecraft:yellow_terracotta",
    "minecraft:lime_terracotta",
    "minecraft:green_terracotta",
    "minecraft:cyan_terracotta",
    "minecraft:light_blue_terracotta",
    "minecraft:blue_terracotta",
    "minecraft:purple_terracotta",
    "minecraft:magenta_terracotta",
    "minecraft:pink_terracotta",

    //////////////////////
    /////// Wool /////////
    //////////////////////
    "minecraft:white_wool",
    "minecraft:light_gray_wool",
    "minecraft:gray_wool",
    "minecraft:black_wool",
    "minecraft:brown_wool",
    "minecraft:red_wool",
    "minecraft:orange_wool",
    "minecraft:yellow_wool",
    "minecraft:lime_wool",
    "minecraft:green_wool",
    "minecraft:cyan_wool",
    "minecraft:light_blue_wool",
    "minecraft:blue_wool",
    "minecraft:purple_wool",
    "minecraft:magenta_wool",
    "minecraft:pink_wool",

    ////////////////////
    /// Random Stuff ///
    ////////////////////
    "minecraft:snow",
    "minecraft:moss_block",
    "minecraft:obsidian",
    "minecraft:crying_obsidian",
    "minecraft:bedrock",
    "minecraft:soul_sand",
    "minecraft:magma",
    "minecraft:end_stone",
    "minecraft:coarse_dirt",
    "minecraft:red_sand",
    "minecraft:sand",
    "minecraft:blackstone",
    "minecraft:andesite",
    "minecraft:diorite",
    "minecraft:granite",
    "minecraft:netherite_block",
    "minecraft:diamond_block",
    "minecraft:lapis_block",
    "minecraft:iron_block",
    "minecraft:emerald_block",
    "minecraft:gold_block",
    "minecraft:coal_block",
    "minecraft:gravel",
    "minecraft:netherrack",
    "minecraft:grass_block",
    "minecraft:dirt",
    "minecraft:glass",
    "minecraft:deepslate",

    /////////////////////
    /////// Glass ///////
    /////////////////////
    "minecraft:white_stained_glass",
    "minecraft:light_gray_stained_glass",
    "minecraft:gray_stained_glass",
    "minecraft:black_stained_glass",
    "minecraft:brown_stained_glass",
    "minecraft:red_stained_glass",
    "minecraft:orange_stained_glass",
    "minecraft:yellow_stained_glass",
    "minecraft:lime_stained_glass",
    "minecraft:green_stained_glass",
    "minecraft:cyan_stained_glass",
    "minecraft:light_blue_stained_glass",
    "minecraft:blue_stained_glass",
    "minecraft:purple_stained_glass",
    "minecraft:magenta_stained_glass",
    "minecraft:pink_stained_glass",
    "minecraft:tinted_glass",
    //////////////////////
    //////// logs ////////
    //////////////////////
    "minecraft:acacia_log",
    "minecraft:stripped_acacia_log",
    "minecraft:birch_log",
    "minecraft:stripped_birch_log",
    "minecraft:cherry_log",
    "minecraft:stripped_cherry_log",
    "minecraft:dark_oak_log",
    "minecraft:stripped_dark_oak_log",
    "minecraft:jungle_log",
    "minecraft:stripped_jungle_log",
    "minecraft:mangrove_log",
    "minecraft:stripped_mangrove_log",
    "minecraft:oak_log",
    "minecraft:stripped_oak_log",
    "minecraft:spruce_log",
    "minecraft:stripped_spruce_log",
    ///////////////////
    ////// wood ///////
    ///////////////////
    "minecraft:acacia_wood",
    "minecraft:stripped_acacia_wood",
    "minecraft:birch_wood",
    "minecraft:stripped_birch_wood",
    "minecraft:cherry_wood",
    "minecraft:stripped_cherry_wood",
    "minecraft:dark_oak_wood",
    "minecraft:stripped_dark_oak_wood",
    "minecraft:jungle_wood",
    "minecraft:stripped_jungle_wood",
    "minecraft:mangrove_wood",
    "minecraft:stripped_mangrove_wood",
    "minecraft:oak_wood",
    "minecraft:stripped_oak_wood",
    "minecraft:spruce_wood",
    "minecraft:stripped_spruce_wood"
]


//  "minecraft:",

world.beforeEvents.itemUseOn.subscribe((e) => {
    
    if(e.block.typeId !== "fr:framedslab" || e.source.isSneaking || !acceptedBlocks.includes(e.itemStack.typeId)) 
        return
    let itemId = acceptedBlocks.indexOf(e.itemStack.typeId) + 1

    
    let texturesetId = Math.floor(itemId / 16)

    
    if(String(Math.abs(itemId - (texturesetId * 16))) == e.block.permutation.getState("fr:framedtexture") && String(texturesetId) == e.block.permutation.getState("fr:textureset"))
        return
    e.cancel = true

    const equippable = e.source.getComponent("minecraft:equippable");
    const mainhand = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

    if (e.source.getGameMode() !== GameMode.creative) {
        if (mainhand.amount > 1) {
            system.run(() => {
                mainhand.amount --;
            });
        } else {
            system.run(() => {
                mainhand.setItem(undefined); // Remove the item stack
            });
        }
    }
    

    let x = e.block.x
    let y = e.block.y
    let z = e.block.z
    
    e.source.runCommandAsync('/setblock ' + x + " " + y + " " + z + 
        ' Fr:framedslab["fr:framedtexture"="' + Math.abs(itemId - (texturesetId * 16)) + '", "minecraft:vertical_half"="' 
        + e.block.permutation.getState("minecraft:vertical_half") + '", "fr:textureset"="' + texturesetId + '"]')
});

